=== debian/changelog ===
ros-kinetic-libmynteye (0.1.3-0xenial) xenial; urgency=high

  * error with Opencv3 so return to libopencv

 -- John Zhao <johnzhao@slightech.com>  Mon, 24 Sep 2018 16:00:00 -0000

ros-kinetic-libmynteye (0.1.2-0xenial) xenial; urgency=high

  * change libopencv to Opencv3

 -- John Zhao <johnzhao@slightech.com>  Sun, 09 Sep 2018 16:00:00 -0000

ros-kinetic-libmynteye (0.1.1-0xenial) xenial; urgency=high

  * modify package version

 -- John Zhao <johnzhao@slightech.com>  Wed, 05 Sep 2018 16:00:00 -0000

ros-kinetic-libmynteye (0.1.0-0xenial) xenial; urgency=high

  * first version

 -- John Zhao <johnzhao@slightech.com>  Tue, 04 Sep 2018 16:00:00 -0000
