=== debian/control ===
Source: ros-kinetic-libmynteye
Section: misc
Priority: extra
Maintainer: John Zhao <johnzhao@slightech.com>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, ros-kinetic-catkin
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-libmynteye
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: The mynt eye sdk package
